using MySqlConnector;

namespace Tiger.Game.Habbos;

public class Habbo
{
    public uint Id { get; }
    public string Username { get; }
    public string Email { get; }
    public DateTime AccountCreated { get; }
    public DateTime LastLogin { get; }
    public string Motto { get; set; }
    public string Figure { get; set; }
    public string Gender { get; set; }
    public byte Rank { get; set; }
    public uint Credits { get; set; }
    public bool Online { get; set; }
    public uint HomeRoom { get; set; }
    public uint AchievementScore { get; set; }
    public uint GroupId { get; set; }

    public Habbo(MySqlDataReader reader)
    {
        Id = reader.GetUInt32("id");
        Username = reader.GetString("username");
        Email = reader.GetString("email");
        AccountCreated = reader.GetDateTime("account_created");
        LastLogin = reader.GetDateTime("last_login");
        Motto = reader.GetString("motto");
        Figure = reader.GetString("figure");
        Gender = reader.GetString("gender");
        Rank = reader.GetByte("rank");
        Credits = reader.GetUInt32("credits");
        Online = reader.GetBoolean("online");
        HomeRoom = reader.GetUInt32("home_room");
        AchievementScore = reader.GetUInt32("achievement_score");
        GroupId = reader.GetUInt32("group_id");
    }
}