using Tiger.Storage;

namespace Tiger.Game.Habbos;

public class HabboDao : IHabboDao
{
    private readonly IDatabaseHelper _databaseHelper;

    public HabboDao(IDatabaseHelper databaseHelper)
    {
        _databaseHelper = databaseHelper;
    }

    public async Task<Habbo?> GetHabboBySsoAsync(string sso)
    {
        await using var dbConnection = _databaseHelper.GetConnection();
        var resultSet =
            await dbConnection.GetResultSet("SELECT * FROM habbos WHERE sso_ticket = @sso LIMIT 1", ("@sso", sso));
        if (await resultSet.ReadAsync())
        {
            return new Habbo(resultSet);
        }

        return null;
    }
}