using System.Collections.ObjectModel;
using Tiger.Storage;

namespace Tiger.Game.Settings;

public class SettingsDao : ISettingsDao
{
    private readonly IDatabaseHelper _databaseHelper;

    public SettingsDao(IDatabaseHelper databaseHelper)
    {
        _databaseHelper = databaseHelper;
    }

    public async Task<IReadOnlyDictionary<string, object>> GetSettingsAsync()
    {
        var settings = new Dictionary<string, object>();
        await using var dbConnection = _databaseHelper.GetConnection();
        await using var resultSet = await dbConnection.GetResultSet("SELECT * FROM settings");
        while (await resultSet.ReadAsync())
        {
            settings.Add(resultSet.GetString("skey"), resultSet.GetValue(resultSet.GetOrdinal("value")));
        }

        return new ReadOnlyDictionary<string, object>(settings);
    }
}